"""
Turtleグラフィックスのプログラム　その５
シェルピンスキーのギャスケットを描く
"""
import turtle as t

def triangle(size):
	""" 三角形を描く
	
	Args:
        size: １辺の長さ
	"""
	t.begin_fill()
	t.pd()
	for i in range(3):
		t.fd(size)
		t.lt(120)
	t.pu()
	t.end_fill()

def sierpinski(size):
	"""	シェルピンスキーのギャスケットを描く再帰呼び出し関数
	
	Args:
        size: １辺の長さ
	"""
	if size<20.0:
		triangle(size)
		return
	else:
		# 左下
		sierpinski(size/2)
		
        # 右下
		t.fd(size/2)
		sierpinski(size/2)

        # 上
		t.lt(120)
		t.fd(size/2)
		t.rt(120)
		sierpinski(size/2)
		
        # スタート地点に戻る
		t.rt(120)
		t.fd(size/2)
		t.lt(120)

t.shape('turtle')
t.speed(0)

t.up()
t.goto(-200, -200) # 左下に移動
#teleport(-200, -200) #? python3.12で追加されたTurtleの関数．上の２行を１行で書ける．

t.color('blue', 'yellow') # 線の色，塗りつぶしの色

sierpinski(400)

t.mainloop()