"""
オブジェクト指向プログラミング
サンプル１「クラスの作成」
"""

class Student:
    """Student:学生番号と氏名を紐づけて管理するクラス
    
    Attributes:
        count (int): 登録済み人数（クラス変数） 
        self.id (int): 学生番号（インスタンス変数）
        self.name (str): 氏名（インスタンス変数）
    """
    count = 0 # クラス変数を初期化

    def __init__(self, id=-1, name='none'):
        self.id = id
        self.name = name
        Student.count += 1
    
    def info(self):
        print(f"学籍番号:{self.id:04d}\t氏名:{self.name}, {Student.count}名が登録されています．")

a = Student()
b = Student(1234, "taro")

print(f"id:{a.id}, name:{a.name}, count:{a.count}")

a.info()
b.info()

c = Student(2356, 'hanako')
c.info()
a.info()
