"""
オブジェクト指向プログラミング
サンプル２「クラスの継承」
"""

class Student:
    """Student:学生番号と氏名を紐づけて管理するクラス
    
    Attributes:
        count (int): 登録済み人数（クラス変数） 
        self.id (int): 学生番号（インスタンス変数）
        self.name (str): 氏名（インスタンス変数）
    """
    count = 0 #? 登録済み人数（クラス変数）

    def __init__(self, id=0, name='none'):
        self.id = id
        self.name = name
        Student.count += 1
    
    def info(self):
        print(f"学籍番号:{self.id:04d}\t氏名:{self.name}, {Student.count}名が登録されています．")


class InternationalStudent(Student):
    """Studentクラスを継承した留学生の国籍情報を追加したクラス

    Additional Attributes:
        self.nationality: 国籍
    """
    def __init__(self, id, name, nationality='none'):
        super().__init__(id, name) #Studentクラスの初期化を実施
        self.nationality = nationality
    
    def info(self):
        print(f"学籍番号:{self.id:04d}\t氏名:{self.name} 国籍:{self.nationality}, {Student.count}名が登録されています．")


a = Student()
b = Student(1234, "taro")

a.info()
b.info()

c = Student(2356, 'hanako')
c.info()
a.info()

d = InternationalStudent(555, 'john', 'USA')
d.info()

b.info()
