"""
Sierpinskiの三角形を描くプログラム
"""

import turtle as t #モジュール名を省略して利用

def triangle(size):
	""" 三角形を描く
	
	Args:
        size: １辺の長さ
	"""
	t.begin_fill()
	t.pd()
	t.fd(size)
	t.lt(120)
	t.fd(size)
	t.lt(120)
	t.fd(size)
	t.pu()
	t.lt(120)
	t.end_fill()

def sierpinski(size):
	""" シェルピンスキーの三角形を描く
	
	1辺の長さが20以上なら，3つの三角形に分割することを再帰的に繰り返す．
	
	Args:
        size: １辺の長さ
	"""

	if size<20.0:
		triangle(size)
		return
	else:
		sierpinski(size/2.0)
		t.fd(size/2.0)
		sierpinski(size/2.0)
		t.lt(120)
		t.fd(size/2.0)
		t.rt(120)
		sierpinski(size/2.0)
		t.rt(120)
		t.fd(size/2.0)
		t.lt(120)

t.shape('turtle')
triangle(100)
t.speed(0)
t.color('green', 'yellow')
sierpinski(100)
t.mainloop()
