"""
PyAutoGUIを用いて
Windowsのpaintアプリを自動的に起動して，お絵かきをするプログラム
confidenceを使用するため，opencvのインストールが必要
"""

#%%
import os
import subprocess
import pyautogui as pag

pag.PAUSE = .1 # 毎操作後0.1秒待つ

cwd = os.getcwd()
if cwd.endswith("6_PyAutoGUI"):
    workdir = "."
else:
    workdir = "./Sample2_6_PyAutoGUI"

print(workdir)

#%%
def clickImage(imgPath, confidence=0.9):
    try:
        x, y = pag.locateCenterOnScreen(imgPath, confidence=confidence, grayscale=False)
        print(f"Find {imgPath} at ({x},{y}).")
        pag.leftClick(x, y)
    except pag.ImageNotFoundException:
        print(f'cannot find {imgPath}')
    
    return x, y


#%%
# paintをWindowsキーから検索で起動
# pag.press("win") #windowsキーを押す
# pag.sleep(1)
# pag.write("paint") #paintを検索
# pag.press("enter") #Enterキーで実行（Paintを起動）

# paintをコマンド起動（サブプロセスとして起動，終了を待たない）
subprocess.Popen('mspaint.exe')

pag.sleep(1) #立ち上がるのを1秒待つ

w, h = pag.size() #画面サイズを取得
print(w, h) #画面サイズ

x1, y1 = clickImage(os.path.join(workdir, 'PenTool.png')) #ペンを選択
x2, y2 = clickImage(os.path.join(workdir, 'ColorBlue.png')) #青を選択

# 画面の中央で描き始める
pag.moveTo((x1+x2)//2, (y1+y2)//2+400)
pag.mouseDown()

#相対移動距離を指定してペンを移動
for x in range(10, 400, 20):
    pag.drag(x, 0, .1)
    pag.drag(0, x, .1)
    pag.drag(-x-10, 0, .1)
    pag.drag(0, -x-10, .1)

#! 実行を途中で止めたい場合，マウスカーソルを左上に持っていくと Fail-safe が働く．

# %%
