"""
Excelでグラフを描く
"""
#%%
import os
from openpyxl import load_workbook
from openpyxl.chart import Reference, LineChart

from getWorkingDir import getWorkDir

work_dir = getWorkDir("Sample2_7_openpyxl")

load_path = os.path.join(work_dir, "cloth_sales.xlsx")
save_path = os.path.join(work_dir, "sample_4A.xlsx")

#%%
wb = load_workbook(load_path, data_only=True)
ws = wb.active

rmin = ws.min_row
rmax = ws.max_row
cmin = ws.min_column
cmax = ws.max_column

chart = LineChart()

data = Reference(ws, min_col=cmin+1, min_row=rmin, max_col=cmax, max_row=rmax)
chart.add_data(data, titles_from_data=True)

labels = Reference(ws, min_col=cmin, min_row=rmin+1, max_row=rmax)  # 項目名の設定
chart.set_categories(labels)

chart.title = 'Sample Chart'  # グラフタイトル
chart.x_axis.title = 'TYPES'  # 軸ラベル
chart.y_axis.title = 'SALES'
chart.anchor = 'A8'  # グラフの表示位置
chart.width = 16  # グラフのサイズ
chart.height = 8

ws.add_chart(chart)
wb.save(save_path)