"""
先に treat_excel1.py, treat_excel2.py を順に実行し， 
myworkbook2.xlsx ファイルが作成された後，
myworkbook2.xlsx を Excelで開き，myworkbook2a.xlsxとして保存し直した状態で実行すること
"""


#%%
# カレントディレクトリを取得し，ファイルの入出力場所（work_dir）を指定する
import os
from getWorkingDir import getWorkDir

work_dir = getWorkDir("Sample2_7_openpyxl")

load_path = os.path.join(work_dir, 'myworkbook2a.xlsx')  # 読み込むExcelファイルのパス
print(load_path)

#%%
from openpyxl import load_workbook

# 通常，data_only=False の状態で読み込まれ，数式を参照する
wb1 = load_workbook(load_path)

ws1 = wb1['9x9']
print("dataonly=False : ", ws1['J1'].value)
wb1.close()


# 読み込み時に data_only=True とすると，計算結果を読み込む
wb2 = load_workbook(load_path, data_only=True)

ws2 = wb2['9x9']
print("dataonly=True : ", ws2['J1'].value)
wb2.close()
