"""
別途数字別にフォルダ別で保存したMnistの数字画像を，Excelの列に並べる
"""

#%%
import os
from openpyxl import Workbook
from openpyxl.drawing.image import Image as xlImage
from openpyxl.utils.cell import get_column_letter

from getWorkingDir import getWorkDir

work_dir = getWorkDir("Sample2_7_openpyxl")

folder_path = os.path.join(work_dir, 'images')
output_path = os.path.join(work_dir, 'mnist_images.xlsx')  # 保存するExcelファイルのパス

print(folder_path)
print(output_path)

#%%
# Excelファイルを作成
wb = Workbook()
ws = wb.active

# 10列分の列名
#cols = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J']
#for num, col in enumerate(cols):

for num in range(10):
    col = get_column_letter(num+1)
    print(col)

    for i in range(100):
        # 画像ファイルを読み込み
        img = xlImage(os.path.join(folder_path, str(num), f"{i:03d}.png"))

        # 行・列を指定してセルに画像を挿入
        ws.add_image(img, f"{col}{i+1}")

        # 行の高さを指定（１列目でやれば２列目以後は不要）    
        if num==0:
            #? 行の高さの単位はpoint, 1 point = 1/72 inch = 0.35mm
            #? Windowsの場合，画面解像度が標準(表示倍率100%)で96DPI(Dot Per Inch)なので， 
            #? 行の高さは，画素数を 72/96 = 0.75倍するとちょうどよい
            ws.row_dimensions[i+1].height = 22 #? 28*0.75=21 +1(余白1ピクセル)
    
    # 列の幅を指定
    ws.column_dimensions[col].width = 28/7 #? 画素数を7で割ったもの？ 

print(f"Image Width:{img.width}, Height:{img.height}")

# Excelファイルを保存
wb.save(output_path)
wb.close()
print(f"Excelファイルが作成されました: {output_path}")

# %%
