# ファイル名を決める部分は excel5 からコピー
import os
from getWorkingDir import getWorkDir

work_dir = getWorkDir("Sample2_7_openpyxl")

load_filepath = os.path.join(work_dir, "cloth_sales.xlsx")
save_filepath = os.path.join(work_dir, "sample_ChatGPT_gen.xlsx")

#%%
"""
Chat-GPT4o　へのプロンプト入力
「このファイル(cloth_sales.xlsx)を読み込んで，
openpyxl でカテゴリ別に積み上げ棒グラフを描くプログラムを生成して」
"""

import openpyxl
from openpyxl.chart import BarChart, Reference, Series
from openpyxl.chart.layout import Layout, ManualLayout

# Load the workbook and select the active worksheet
#wb = openpyxl.load_workbook('/mnt/data/cloth_sales.xlsx') # ファイルパスは修正
wb = openpyxl.load_workbook(load_filepath)
ws = wb.active

# Create a BarChart object
chart = BarChart()
chart.type = "col"
chart.grouping = "stacked"
#chart.overlap = 100 #! ここだけ人手で修正が必要だった．
chart.style = 10
chart.title = "カテゴリ別販売数"
chart.y_axis.title = '販売数'
chart.x_axis.title = 'カテゴリー'

# Add data to the chart
data = Reference(ws, min_col=2, min_row=1, max_col=5, max_row=6)
categories = Reference(ws, min_col=1, min_row=2, max_row=6)
chart.add_data(data, titles_from_data=True)
chart.set_categories(categories)

# Customize the chart layout
chart.layout = Layout(
    ManualLayout(
        x=0.25, y=0.25,
        h=0.5, w=0.5
    )
)

# Place the chart on the worksheet
ws.add_chart(chart, "G10")

# Save the workbook
wb.save(save_filepath)

